# -- with check needed to pull dev requires via %%cargo_generate_buildrequires
%bcond_without check

Name:           python-maturin
Version:        1.4.0
Release:        %mkrel 5
Summary:        Build and publish crates with pyo3, rust-cpython and cffi bindings as well as rust binaries as python packages
Group:          Development/Python

License:        MIT OR Apache-2.0
URL:            https://github.com/pyo3/maturin
Source:         %{pypi_source maturin}
# * disable features with missing dependencies:
#   - cross (support for cross compiling with zig / xwin)
#   - upload (support for uploading wheels to PyPI)
# * drop unused test dependencies
Patch1:         0001-drop-unavailable-features-and-unused-dev-dependencie.patch

# * drop incompatible arguments from setuptools_rust cargo invocations
Patch2:         0002-drop-incompatible-cargo-flags-from-setuptools_rust.patch

# * drop #!/usr/bin/env python3 shebang from maturin/__init__.py
Patch3:         0003-remove-shebang-from-non-executable-__init__.py-file.patch

BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros
BuildRequires:  cargo-rpm-macros >= 24

%description
Build and publish crates with pyo3, rust-cpython, cffi and uniffi bindings as
well as rust binaries as python packages.

%package -n     python3-maturin
Summary:        %{summary}
Provides:       maturin = %{version}-%{release}

%description -n python3-maturin
Build and publish crates with pyo3, rust-cpython, cffi and uniffi bindings as
well as rust binaries as python packages.

%prep
%autosetup -p1 -n maturin-%{version}
%cargo_prep

%generate_buildrequires
%pyproject_buildrequires
%cargo_generate_buildrequires

%build
export RUSTFLAGS="%{build_rustflags}"
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files maturin

%if %{with check}
%check
# * skip a test that fails with Rust 1.74+
# * skip tests for which fixtures are not included in published sources
%cargo_test -- -- --skip build_context::test::test_macosx_deployment_target --skip build_options::test::test_find_bridge --skip metadata::test::test_implicit_readme --skip metadata::test::test_merge_metadata_from_pyproject --skip pyproject_toml::tests::test_warn_missing_maturin_version
%endif

%files -n python3-maturin -f %{pyproject_files}
%doc README.md
%license  license-apache license-mit
%{_bindir}/maturin


%changelog
* Fri Dec 29 2023 wally <wally> 1.4.0-5.mga10
+ Revision: 2024007
- build using system rust pkgs

* Thu Dec 28 2023 papoteur <papoteur> 1.4.0-4.mga10
+ Revision: 2023369
- rebuild again for python 3.12

* Sun Dec 10 2023 wally <wally> 1.4.0-3.mga10
+ Revision: 2016909
- rebuild for py3.12

* Wed Dec 06 2023 wally <wally> 1.4.0-2.mga10
+ Revision: 2013568
- provide maturin
- drop extras subpkgs as we don't have python-patchelf nor python-ziglang
- build using %%build_rustflags

* Tue Dec 05 2023 papoteur <papoteur> 1.4.0-1.mga10
+ Revision: 2013362
- imported package python-maturin

